diff --git a/.gitignore b/.gitignore
index ea0808062..0314a5fdf 100644
--- a/.gitignore
+++ b/.gitignore
@@ -147,3 +147,6 @@ build/bin/tic80
 build/bin/tic80-sokol
 out/
 build/bin/
+build/3rd-party/curl/libcurl.pc
+build/3rd-party/curl/curl-config
+build/3rd-party/curl/DartConfiguration.tcl
diff --git a/3rd-party b/3rd-party
index 62c418b27..ba4ac5096 160000
--- a/3rd-party
+++ b/3rd-party
@@ -1 +1 @@
-Subproject commit 62c418b272da3104df4a04a5a280311892d62df5
+Subproject commit ba4ac50969d6045846b60b4d263cbeb5a9840a08
diff --git a/CMakeLists.txt b/CMakeLists.txt
index 3b78065d8..6d6714bc0 100644
--- a/CMakeLists.txt
+++ b/CMakeLists.txt
@@ -3,8 +3,6 @@ cmake_minimum_required(VERSION 3.3)
 project(TIC-80 C CXX)
 message("Building for target : ${CMAKE_SYSTEM_NAME}")
 
-
-
 if(ANDROID OR EMSCRIPTEN)
 	set(BUILD_SOKOL_DEFAULT OFF)
 	set(BUILD_LIBRETRO_DEFAULT OFF)
@@ -282,7 +280,6 @@ target_include_directories(tic80core PRIVATE ${THIRDPARTY_DIR}/squirrel/include)
 target_include_directories(tic80core PRIVATE ${THIRDPARTY_DIR}/moonscript)
 target_include_directories(tic80core PRIVATE ${THIRDPARTY_DIR}/fennel)
 
-add_dependencies(tic80core lua lpeg wren squirrel giflib)
 target_link_libraries(tic80core lua lpeg wren squirrel giflib)
 
 if(LINUX)
@@ -331,7 +328,6 @@ if(BUILD_SDL AND NOT EMSCRIPTEN AND NOT ANDROID)
 		target_link_libraries(sdl-renderer mingw32)
 	endif()
 
-	add_dependencies(sdl-renderer tic80core SDL2-static SDL2main)
 	target_link_libraries(sdl-renderer tic80core SDL2-static SDL2main)
 endif()
 
@@ -406,7 +402,6 @@ target_include_directories(sokol-renderer PRIVATE ${CMAKE_SOURCE_DIR}/include)
 target_include_directories(sokol-renderer PRIVATE ${THIRDPARTY_DIR}/sokol)
 target_include_directories(sokol-renderer PRIVATE ${CMAKE_SOURCE_DIR}/src)
 
-add_dependencies(sokol-renderer tic80core sokol)
 target_link_libraries(sokol-renderer tic80core sokol)
 endif()
 
@@ -440,7 +435,6 @@ if(BUILD_LIBRETRO)
 		RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib
 	)
 
-	add_dependencies(tic80_libretro tic80core)
 	target_link_libraries(tic80_libretro tic80core)
 	set_target_properties(tic80_libretro PROPERTIES PREFIX "")
 endif()
@@ -513,32 +507,29 @@ if(ANDROID)
 endif()
 
 if(NOT EMSCRIPTEN)
-	add_dependencies(sdlgpu SDL2-static)
 	target_link_libraries(sdlgpu SDL2-static)
 endif()
 
 endif()
 
 ################################
-# SDL NET
+# CURL
 ################################
 
-if(BUILD_SDL)
-set(SDLNET_DIR ${THIRDPARTY_DIR}/SDL2_net-2.0.1)
-set(SDLNET_SRC 
-	${SDLNET_DIR}/SDLnet.c
-	${SDLNET_DIR}/SDLnetTCP.c
-	${SDLNET_DIR}/SDLnetselect.c
-)
-
-add_library(sdlnet STATIC ${SDLNET_SRC})
-target_include_directories(sdlnet PRIVATE ${THIRDPARTY_DIR}/sdl2/include)
+set(BUILD_SHARED_LIBS OFF CACHE BOOL "")
 
 if(WIN32)
-	target_link_libraries(sdlnet ws2_32)
-endif()
+    set(CURL_STATIC_CRT ON CACHE BOOL "")
 endif()
 
+set(CMAKE_USE_OPENSSL OFF CACHE BOOL "" )
+set(HTTP_ONLY ON CACHE BOOL "")
+set(BUILD_CURL_EXE OFF CACHE BOOL "")
+set(CURL_CA_BUNDLE "none" CACHE STRING "")
+set(CURL_CA_PATH "none" CACHE STRING "")
+
+add_subdirectory(${THIRDPARTY_DIR}/curl)
+
 ################################
 # ZLIB
 ################################
@@ -574,7 +565,6 @@ if(BUILD_DEMO_CARTS)
 
 	target_include_directories(bin2txt PRIVATE ${THIRDPARTY_DIR}/zlib-1.2.11)
 
-	add_dependencies(bin2txt zlib)
 	target_link_libraries(bin2txt zlib)
 
 	file(GLOB DEMO_CARTS ${CMAKE_SOURCE_DIR}/demos/*.tic )
@@ -629,6 +619,7 @@ set(TIC80LIB_SRC
 	${TIC80LIB_DIR}/dialog.c
 	${TIC80LIB_DIR}/menu.c
 	${TIC80LIB_DIR}/surf.c
+	${TIC80LIB_DIR}/net.c
 )
 
 set(TIC80_OUTPUTS tic80)
@@ -649,9 +640,9 @@ foreach(TIC80_OUTPUT ${TIC80_OUTPUTS})
 	target_include_directories(${TIC80_OUTPUT}lib PRIVATE ${THIRDPARTY_DIR}/giflib-5.1.4/lib)
 	target_include_directories(${TIC80_OUTPUT}lib PRIVATE ${THIRDPARTY_DIR}/zlib-1.2.11)
 	target_include_directories(${TIC80_OUTPUT}lib PRIVATE ${THIRDPARTY_DIR}/lua-5.3.1/src)
+	target_include_directories(${TIC80_OUTPUT}lib PRIVATE ${THIRDPARTY_DIR}/curl/include)
 
-	add_dependencies(${TIC80_OUTPUT}lib tic80core zlib)
-	target_link_libraries(${TIC80_OUTPUT}lib tic80core zlib)
+	target_link_libraries(${TIC80_OUTPUT}lib tic80core zlib libcurl)
 
 endforeach()
 
@@ -672,7 +663,7 @@ foreach(TIC80_OUTPUT ${TIC80_OUTPUTS})
 		set(TIC80_SRC ${TIC80_SRC} ${CMAKE_SOURCE_DIR}/src/ext/file_dialog.m)
 	endif()
 
-	set(TIC80_SRC ${TIC80_SRC} ${CMAKE_SOURCE_DIR}/src/net.c src/system/sdlgpu.c)
+	set(TIC80_SRC ${TIC80_SRC} src/system/sdlgpu.c)
 
 	if(WIN32)
 		set(TIC80_SRC ${TIC80_SRC} build/windows/tic80.rc)
@@ -698,7 +689,6 @@ foreach(TIC80_OUTPUT ${TIC80_OUTPUTS})
 
 	target_include_directories(${TIC80_OUTPUT} PRIVATE ${CMAKE_SOURCE_DIR}/include)
 	target_include_directories(${TIC80_OUTPUT} PRIVATE ${CMAKE_SOURCE_DIR}/src)
-	target_include_directories(${TIC80_OUTPUT} PRIVATE ${THIRDPARTY_DIR}/SDL2_net-2.0.1)
 	target_include_directories(${TIC80_OUTPUT} PRIVATE ${THIRDPARTY_DIR}/sdl2/include)
 
 	target_include_directories(${TIC80_OUTPUT} PRIVATE ${THIRDPARTY_DIR}/sdl-gpu/include)
@@ -710,12 +700,10 @@ foreach(TIC80_OUTPUT ${TIC80_OUTPUTS})
 	if(EMSCRIPTEN)
 		set_target_properties(${TIC80_OUTPUT} PROPERTIES LINK_FLAGS "-s WASM=1 -s USE_SDL=2 -s TOTAL_MEMORY=67108864 --pre-js ${CMAKE_SOURCE_DIR}/build/html/prejs.js")		
 	elseif(NOT ANDROID)
-		add_dependencies(${TIC80_OUTPUT} SDL2main)
 		target_link_libraries(${TIC80_OUTPUT} SDL2main)
 	endif()
 
-	add_dependencies(${TIC80_OUTPUT} ${TIC80_OUTPUT}lib sdlnet sdlgpu)
-	target_link_libraries(${TIC80_OUTPUT} ${TIC80_OUTPUT}lib sdlnet sdlgpu)
+	target_link_libraries(${TIC80_OUTPUT} ${TIC80_OUTPUT}lib sdlgpu)
 
 	if(LINUX)
 		include(FindPkgConfig)
@@ -765,7 +753,6 @@ foreach(TIC80_OUTPUT ${TIC80_OUTPUTS})
 
 	target_include_directories(${TIC80_OUTPUT}-sokol PRIVATE ${CMAKE_SOURCE_DIR}/include)
 	target_include_directories(${TIC80_OUTPUT}-sokol PRIVATE ${CMAKE_SOURCE_DIR}/src)
-	target_include_directories(${TIC80_OUTPUT}-sokol PRIVATE ${THIRDPARTY_DIR}/SDL2_net-2.0.1)
 	target_include_directories(${TIC80_OUTPUT}-sokol PRIVATE ${THIRDPARTY_DIR}/sdl2/include)
 
 	target_include_directories(${TIC80_OUTPUT}-sokol PRIVATE ${THIRDPARTY_DIR}/sokol)
@@ -774,7 +761,6 @@ foreach(TIC80_OUTPUT ${TIC80_OUTPUTS})
 		target_link_libraries(${TIC80_OUTPUT}-sokol mingw32)
 	endif()
 
-	add_dependencies(${TIC80_OUTPUT}-sokol ${TIC80_OUTPUT}lib sokol)
 	target_link_libraries(${TIC80_OUTPUT}-sokol ${TIC80_OUTPUT}lib sokol)
 
 	if(LINUX)
diff --git a/src/console.c b/src/console.c
index 69fb727f9..a481c6590 100644
--- a/src/console.c
+++ b/src/console.c
@@ -2673,15 +2673,19 @@ static lua_State* netLuaInit(u8* buffer, s32 size)
 {
 	if (buffer && size)
 	{
+		char* script = calloc(1, size + 1);
+		memcpy(script, buffer, size);
 		lua_State* lua = luaL_newstate();
 
 		if(lua)
 		{
-			if(luaL_loadstring(lua, (char*)buffer) == LUA_OK && lua_pcall(lua, 0, LUA_MULTRET, 0) == LUA_OK)
+			if(luaL_loadstring(lua, (char*)script) == LUA_OK && lua_pcall(lua, 0, LUA_MULTRET, 0) == LUA_OK)
 				return lua;
 
 			else lua_close(lua);
 		}
+
+		free(script);
 	}
 
 	return NULL;
@@ -2702,6 +2706,7 @@ static NetVersion netVersionRequest()
 	if(buffer && size)
 	{
 		lua_State* lua = netLuaInit(buffer, size);
+		free(buffer);
 
 		if(lua)
 		{
diff --git a/src/fs.c b/src/fs.c
index 4b93a3d3d..91d3c4cbe 100644
--- a/src/fs.c
+++ b/src/fs.c
@@ -196,15 +196,20 @@ static lua_State* netLuaInit(u8* buffer, s32 size)
 {
     if (buffer && size)
     {
+		char* script = calloc(1, size + 1);
+		memcpy(script, buffer, size);
+
         lua_State* lua = luaL_newstate();
 
         if(lua)
         {
-            if(luaL_loadstring(lua, (char*)buffer) == LUA_OK && lua_pcall(lua, 0, LUA_MULTRET, 0) == LUA_OK)
+            if(luaL_loadstring(lua, script) == LUA_OK && lua_pcall(lua, 0, LUA_MULTRET, 0) == LUA_OK)
                 return lua;
 
             else lua_close(lua);
         }
+
+        free(script);
     }
 
     return NULL;
@@ -214,84 +219,88 @@ static void onDirResponse(u8* buffer, s32 size, void* data)
 {
 	NetDirData* netDirData = (NetDirData*)data;
 
-	lua_State* lua = netLuaInit(buffer, size);
-
-	if(lua)
+	if(buffer && size)
 	{
-		{
-			lua_getglobal(lua, "folders");
+		lua_State* lua = netLuaInit(buffer, size);
+		free(buffer);
 
-			if(lua_type(lua, -1) == LUA_TTABLE)
+		if(lua)
+		{
 			{
-				s32 count = (s32)lua_rawlen(lua, -1);
+				lua_getglobal(lua, "folders");
 
-				for(s32 i = 1; i <= count; i++)
+				if(lua_type(lua, -1) == LUA_TTABLE)
 				{
-					lua_geti(lua, -1, i);
+					s32 count = (s32)lua_rawlen(lua, -1);
 
+					for(s32 i = 1; i <= count; i++)
 					{
-						lua_getfield(lua, -1, "name");
-						if(lua_isstring(lua, -1))
-							netDirData->callback(lua_tostring(lua, -1), NULL, 0, netDirData->data, true);
+						lua_geti(lua, -1, i);
+
+						{
+							lua_getfield(lua, -1, "name");
+							if(lua_isstring(lua, -1))
+								netDirData->callback(lua_tostring(lua, -1), NULL, 0, netDirData->data, true);
+
+							lua_pop(lua, 1);
+						}
 
 						lua_pop(lua, 1);
 					}
-
-					lua_pop(lua, 1);
 				}
-			}
 
-			lua_pop(lua, 1);
-		}
-
-		{
-			lua_getglobal(lua, "files");
+				lua_pop(lua, 1);
+			}
 
-			if(lua_type(lua, -1) == LUA_TTABLE)
 			{
-				s32 count = (s32)lua_rawlen(lua, -1);
+				lua_getglobal(lua, "files");
 
-				for(s32 i = 1; i <= count; i++)
+				if(lua_type(lua, -1) == LUA_TTABLE)
 				{
-					lua_geti(lua, -1, i);
-
-					char hash[FILENAME_MAX] = {0};
-					char name[FILENAME_MAX] = {0};
+					s32 count = (s32)lua_rawlen(lua, -1);
 
+					for(s32 i = 1; i <= count; i++)
 					{
-						lua_getfield(lua, -1, "hash");
-						if(lua_isstring(lua, -1))
-							strcpy(hash, lua_tostring(lua, -1));
+						lua_geti(lua, -1, i);
 
-						lua_pop(lua, 1);
-					}
+						char hash[FILENAME_MAX] = {0};
+						char name[FILENAME_MAX] = {0};
 
-					{
-						lua_getfield(lua, -1, "name");
+						{
+							lua_getfield(lua, -1, "hash");
+							if(lua_isstring(lua, -1))
+								strcpy(hash, lua_tostring(lua, -1));
 
-						if(lua_isstring(lua, -1))
-							strcpy(name, lua_tostring(lua, -1));
+							lua_pop(lua, 1);
+						}
 
-						lua_pop(lua, 1);
-					}
+						{
+							lua_getfield(lua, -1, "name");
 
-					{
-						lua_getfield(lua, -1, "id");
+							if(lua_isstring(lua, -1))
+								strcpy(name, lua_tostring(lua, -1));
 
-						if(lua_isinteger(lua, -1))
-							netDirData->callback(name, hash, lua_tointeger(lua, -1), netDirData->data, false);
+							lua_pop(lua, 1);
+						}
+
+						{
+							lua_getfield(lua, -1, "id");
+
+							if(lua_isinteger(lua, -1))
+								netDirData->callback(name, hash, lua_tointeger(lua, -1), netDirData->data, false);
+
+							lua_pop(lua, 1);
+						}
 
 						lua_pop(lua, 1);
 					}
-
-					lua_pop(lua, 1);
 				}
+
+				lua_pop(lua, 1);
 			}
 
-			lua_pop(lua, 1);
+			lua_close(lua);
 		}
-
-		lua_close(lua);
 	}
 }
 
diff --git a/src/net.c b/src/net.c
index fe81b57e1..b645f69b1 100644
--- a/src/net.c
+++ b/src/net.c
@@ -22,206 +22,74 @@
 
 #include "net.h"
 #include "tic.h"
-#include "SDL_net.h"
 
 #include <stdlib.h>
 #include <stdio.h>
 
+#include <curl/curl.h>
+
 struct Net
 {
-	struct
-	{
-		u8* buffer;
-		s32 size;
-		char path[FILENAME_MAX];
-	} cache;
+	struct Curl_easy* curl;
 };
 
-
-typedef void(*NetResponse)(u8* buffer, s32 size, void* data);
-
-#if defined(__EMSCRIPTEN__)
-
-static void getRequest(Net* net, const char* path, NetResponse callback, void* data)
-{
-	callback(NULL, 0, data);
-}
-
-#else
-
-static void netClearCache(Net* net)
-{
-	if(net->cache.buffer)
-		free(net->cache.buffer);
-
-	net->cache.buffer = NULL;
-	net->cache.size = 0;
-	memset(net->cache.path, 0, sizeof net->cache.path);
-}
-
 typedef struct
 {
-	u8* data;
-	s32 size;
-}Buffer;
+    void* buffer;
+    s32 size;
+} CurlData;
 
-static Buffer httpRequest(const char* path, s32 timeout)
+static size_t writeCallback(void *contents, size_t size, size_t nmemb, void *userp)
 {
-	Buffer buffer = {.data = NULL, .size = 0};
+	CurlData* data = (CurlData*)userp;
 
-	{
-		IPaddress ip;
-
-		if (SDLNet_ResolveHost(&ip, TIC_HOST, 80) >= 0)
-		{
-			TCPsocket sock = SDLNet_TCP_Open(&ip);
-
-			if (sock)
-			{
-				SDLNet_SocketSet set = SDLNet_AllocSocketSet(1);
-
-				if(set)
-				{
-					SDLNet_TCP_AddSocket(set, sock);
-
-					{
-						char message[FILENAME_MAX];
-						memset(message, 0, sizeof message);
-						sprintf(message, "GET %s HTTP/1.0\r\nHost: " TIC_HOST "\r\n\r\n", path);
-						SDLNet_TCP_Send(sock, message, (s32)strlen(message) + 1);
-					}
-
-					if(SDLNet_CheckSockets(set, timeout) == 1 && SDLNet_SocketReady(sock))
-					{
-						enum {Size = 4*1024+1};
-						buffer.data = malloc(Size);
-						s32 size = 0;
-
-						for(;;)
-						{
-							size = SDLNet_TCP_Recv(sock, buffer.data + buffer.size, Size-1);
-
-							if(size > 0)
-							{
-								buffer.size += size;
-								buffer.data = realloc(buffer.data, buffer.size + Size);
-							}
-							else break;
-						}
-
-						buffer.data[buffer.size] = '\0';
-					}
-					
-					SDLNet_FreeSocketSet(set);
-				}
-
-				SDLNet_TCP_Close(sock);
-			}
-		}
-	}
+	const size_t total = size * nmemb;
+	data->buffer = realloc(data->buffer, data->size + total);
+	memcpy((u8*)data->buffer + data->size, contents, total);
+	data->size += total;
 
-	return buffer;
+	return total;
 }
 
-static void getRequest(Net* net, const char* path, NetResponse callback, void* data)
+void* netGetRequest(Net* net, const char* path, s32* size)
 {
-	if(strcmp(net->cache.path, path) == 0)
-	{
-		callback(net->cache.buffer, net->cache.size, data);
-	}
-	else
-	{
-		netClearCache(net);
-
-		bool done = false;
-
-		enum {Timeout = 3000};
-		Buffer buffer = httpRequest(path, Timeout);
-
-		if(buffer.data && buffer.size)
-		{
-			if(strstr((char*)buffer.data, "200 OK"))
-			{
-				s32 contentLength = 0;
+	CurlData data = {NULL, 0};
 
-				{
-					static const char ContentLength[] = "Content-Length:";
-
-					char* start = strstr((char*)buffer.data, ContentLength);
-
-					if(start)
-						contentLength = atoi(start + sizeof(ContentLength));
-				}
-
-				static const char Start[] = "\r\n\r\n";
-				u8* start = (u8*)strstr((char*)buffer.data, Start);
-
-				if(start)
-				{
-					strcpy(net->cache.path, path);
-					net->cache.size = contentLength ? contentLength : buffer.size - (s32)(start - buffer.data);
-					net->cache.buffer = (u8*)malloc(net->cache.size);
-					memcpy(net->cache.buffer, start + sizeof Start - 1, net->cache.size);
-					callback(net->cache.buffer, net->cache.size, data);
-					done = true;
-				}
-			}
-
-			free(buffer.data);
-		}
-
-		if(!done)
-			callback(NULL, 0, data);
+	if(net->curl)
+	{
+		char url[FILENAME_MAX] = "http://" TIC_HOST;
+		strcat(url, path);
+		
+		curl_easy_setopt(net->curl, CURLOPT_URL, url);
+		curl_easy_setopt(net->curl, CURLOPT_WRITEDATA, &data);
+
+		if(curl_easy_perform(net->curl) != CURLE_OK)
+			return NULL;
 	}
-}
-
-#endif
-
-typedef struct
-{
-	void* buffer;
-	s32* size;
-} NetGetData;
 
-static void onGetResponse(u8* buffer, s32 size, void* data)
-{
-	NetGetData* netGetData = (NetGetData*)data;
+	*size = data.size;
 
-	netGetData->buffer = malloc(size);
-	*netGetData->size = size;
-	memcpy(netGetData->buffer, buffer, size);
-}
-
-void* netGetRequest(Net* net, const char* path, s32* size)
-{
-	NetGetData netGetData = {NULL, size};
-	getRequest(net, path, onGetResponse, &netGetData);
-
-	return netGetData.buffer;
+    return data.buffer;
 }
 
 Net* createNet()
 {
-	SDLNet_Init();
-
 	Net* net = (Net*)malloc(sizeof(Net));
 
 	*net = (Net)
 	{
-		.cache = 
-		{
-			.buffer = NULL,
-			.size = 0,
-			.path = {0},
-		},
+		.curl = curl_easy_init()
 	};
 
+	curl_easy_setopt(net->curl, CURLOPT_WRITEFUNCTION, writeCallback);
+
 	return net;
 }
 
 void closeNet(Net* net)
 {
+	if(net->curl)
+		curl_easy_cleanup(net->curl);
+
 	free(net);
-	
-	SDLNet_Quit();
-}
\ No newline at end of file
+}
diff --git a/src/system/sokol.c b/src/system/sokol.c
index 7ef670770..cd765c5e5 100644
--- a/src/system/sokol.c
+++ b/src/system/sokol.c
@@ -26,6 +26,7 @@
 #include <limits.h>
 
 #include "system.h"
+#include "net.h"
 #include "system/sokol.h"
 
 static struct
@@ -45,6 +46,8 @@ static struct
 
 	char* clipboard;
 
+    Net* net;
+
 } platform;
 
 static void setClipboardText(const char* text)
@@ -85,7 +88,7 @@ static u64 getPerformanceFrequency()
 
 static void* getUrlRequest(const char* url, s32* size)
 {
-	return NULL;
+	return netGetRequest(platform.net, url, size);
 }
 
 static void goFullscreen()
@@ -391,6 +394,7 @@ static void app_input(const sapp_event* event)
 static void app_cleanup(void)
 {
 	platform.studio->close();
+	closeNet(platform.net);
 	free(platform.audio.samples);
 }
 
@@ -401,6 +405,8 @@ sapp_desc sokol_main(s32 argc, char* argv[])
 	platform.audio.desc.num_channels = TIC_STEREO_CHANNELS;
 	saudio_setup(&platform.audio.desc);
 
+    platform.net = createNet();
+
 	platform.studio = studioInit(argc, argv, saudio_sample_rate(), "./", &systemInterface);
 
 	const s32 Width = TIC80_FULLWIDTH * platform.studio->config()->uiScale;
diff --git a/src/tic.h b/src/tic.h
index cfe879597..35c46ea9d 100644
--- a/src/tic.h
+++ b/src/tic.h
@@ -48,8 +48,8 @@
 #define TIC_NAME "TIC-80"
 #define TIC_NAME_FULL TIC_NAME " tiny computer"
 #define TIC_TITLE TIC_NAME_FULL " " TIC_VERSION_LABEL
-#define TIC_HOST "tic.computer"
-#define TIC_COPYRIGHT "http://" TIC_HOST " (C) 2019"
+#define TIC_HOST "tic80.com"
+#define TIC_COPYRIGHT "https://" TIC_HOST " (C) 2019"
 
 #define TIC_VRAM_SIZE (16*1024) //16K
 #define TIC_RAM_SIZE (TIC_VRAM_SIZE+80*1024) //16K+80K
